
#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include <str.h>

struct string {
	usize len, cap;
	struct str_meta {	
		enum str_ownership owned;
		union _str_meta_inner {
			// `STRF_OWNED` 
			struct {
				_Atomic usize refs; // Number of derrivations from this 
				void (*m_free)(void*); // How to free (when `_MALLOC`).
			} owned;
			// `STRF_DERRIVED`
			struct {
				// String this is derrived from, can be either owned or derrived.
				struct string* _shared parent;
				// `str`'s offset from `parent->str`.
				usize offset;
			} derrived;
		} _inner;
	} meta;
	// The start of this string slice. Regardless of slicing
	char* str;
};

//TODO: We can use offsetof() to reverse the result of `str_new()` from char* (str field) to str_t*.

inline static bool _str_meta_is_owned(enum str_ownership owned)
{
	return AS(owned, u32) & AS(STRF_OWNED, u32);
}

inline static bool _str_is_owned(const str_t*pIN str)
{
	return _str_meta_is_owned(str->meta.owned);
}

static union _str_meta_inner _str_default_meta(enum str_ownership oship)
{
	bool owned = _str_meta_is_owned(oship);
	switch(oship)
	{
		
	}
	TODO("default str metadata");
}

static str_t _str_alloc_bare(usize cap, enum str_ownership owned)
{
	bool is_owned = _str_meta_is_owned(owned);
	struct str_meta meta = {
		.owned = owned,
		._inner = _str_default_meta(owned),
	};
	str_t str = {
		.len = 0,
		.cap = cap,
		.meta = meta,
	};
	str.str = is_owned ? calloc(cap+1, 1) : NULL;
	return str;
}
